--"If we don't respect the rules we make, we're never going to respect each other. I mean, have we learned nothing from watching The Cosby Show?"

_r = math.random _f = math.floor _c = math.cos _s = math.sin _sq = math.sqrt _at2 = math.atan2 _d2r = math.rad _r2d = math.deg _m = math.mod pi = math.pi _min = math.min _max = math.max
gr = love.graphics ti = love.timer kb = love.keyboard ms = love.mouse

math.randomseed(os.time()) _r() _r() _r()

function love.run()
	love.load(arg)
	while true do
  	fps = ti.getFPS()
		ti.step()
		time = ti.getTime()
		dt = ti.getDelta()
		gr.clear()
		love.update(dt)
		love.draw(dt)
    for e,a,b,c in love.event.poll() do
      print("Event:", e, a, b, c)
      if e == "q" then
        if love.audio then love.audio.stop() end
        return
      end
      love.handlers[e](a,b,c)
    end
		ti.sleep(1)
		gr.present()
	end
end

function love.load()
	gr.setFont(love._vera_ttf, 12)

	resetStart()

	calcNorm = true

	points = {}
	poly = {}
	light = {x = 100, y = 80, z = 150, intensity = 1.0}

  object = {}
  object["light"] = { xs = 0, ys = 0, zs = 0, x = 0, y = 0, z = 0, cx, cy, cz, scale_x = 1, scale_y = 1, scale_z = 1, active = true, onscreen = true }

  local c = nil
  local nn = 0
  for np = 1, 100 do
    x = _r(-80,80)
    y = _r(-60,60)
    zz = 0--_r(-1,1)*10
    nn = nn + 1
    n = "obj_" .. nn
    c = {_r(150,200), _r(150,200), _r(150,200)}
    if _r(1,1) == 1 then u = true else u = false end
    object[n] = {
      x = x, y = y, z = zz,
      xs = _r(-100,100)/10, ys = _r(-100,100)/10, zs = _r(-100,100)/10,
      scale_x = 1, scale_y = 1, scale_z = 1,
      active = _r(0,1), update = u, onscreen = true, opacity = 255,
      _st = _r(0,10000)
    }
    loadObject("cube", x*10.5, y*10.5, zz, 0, 0, 1, n, c)
  end
  --object["tea"] = { x=0, y=0, z=0, xs = 0, ys = 0, zs = 0, active = _r(0,1) }
  --loadObject("teapot", 0, 0, 30, .5, .5, .5, "tea", {100,150,100})

	table.insert(points, { x = light.x, y = light.y, z = light.z, cx, cy, cz, nx, ny, dep, s, scale_x = 0, scale_y = 0, scale_z = 0, name = "light" })

	print("Total: " .. (#points) .. " points and " .. (#poly) .. " polys.")

  calculateNormals()
  updateLighting()

	swidth = gr.getWidth()
	sheight = gr.getHeight()
end

function resetStart()
	--Don't change the following
	--Rotation on X, Y and Z axis
	rx = 0 ry = 0 rz = 0
	rxs = 0
	rys = 0
	rzs = 0
	focal = 300
	zoom = 4

	camera = { tiltx = 0, tilty = 0, tiltz = 0, x = 0, y = 0, z = 0 }

	--Change these if you want!
  drawlines = false	--Enable the drawing of the lines
  blacklines = false
	debugtext = true
	shownums = false
	bgcolor = true
	showpoints = false
	gr.setLineWidth(1)
	ambient = {r = 100, g = 100, b = 100}
	offset = 0

	timeforupdate1 = 0
	timefordraw1 = 0
	totalcalcs = 0
end
function stopSpin() rxs = 0 rys = 0 rzs = 0 end --Rotation speed

function love.update(dt)
  local ttxx = ti.getTime()
  timeforupdate1 = 0

	local sx, cx, sy, cy, xz, cz
	local x,y,z, xy,xz, yx,yz, zx,zy, scale
	--Rotate based on speed of rotation on the axis
	rx = (rx + rxs * dt) % 360
	ry = (ry + rys * dt) % 360
	rz = (rz + rzs * dt) % 360

	--Keys
	if love.keyboard.isDown(".") then
    offset = offset + 100 * dt
  end
	if love.keyboard.isDown("up") then
		if zoom < 10 then zoom = zoom + .5 * dt end
	elseif love.keyboard.isDown("down") then
		if zoom > .05 then zoom = zoom - .5 * dt end
	end
	if love.keyboard.isDown("r") then resetStart() end
	if love.keyboard.isDown("s") then stopSpin() end
	if love.keyboard.isDown("lshift") then
		if love.keyboard.isDown("left") then
			if rxs < 360 then rxs = rxs + 10 * dt end
		elseif love.keyboard.isDown("right") then
			if rxs > -360 then rxs = rxs - 10 * dt end
		end
	elseif love.keyboard.isDown("rshift") then
		if love.keyboard.isDown("left") then
			if rzs < 360 then rzs = rzs + 10 * dt end
		elseif love.keyboard.isDown("right") then
			if rzs > -360 then rzs = rzs - 10 * dt end
		end
	else
		if love.keyboard.isDown("left") then
			if rys < 360 then rys = rys + 10 * dt end
		elseif love.keyboard.isDown("right") then
			if rys > -360 then rys = rys - 10 * dt end
		end
	end

	--Find the base locations for the points in 3D space
	sx = _s(degToRad(rx+camera.tilty))
	cx = _c(degToRad(rx+camera.tilty))
	sy = _s(degToRad(ry+camera.tiltz))
	cy = _c(degToRad(ry+camera.tiltz))
	sz = _s(degToRad(rz+camera.tiltx))
	cz = _c(degToRad(rz+camera.tiltx))

  --Calculate position of objects, move them, shrink them,
  --Do whatever's needed before using their values
  for i, o in pairs(object) do
    if totalcalcs > 0 and o.update then
      o.x = o.x + o.xs * dt
      o.y = o.y + o.ys * dt
      o.z = o.z + o.zs * dt
      if o.x < -80 then o.xs = -o.xs end
      if o.x > 80 then o.xs = -o.xs end
      if o.y < -60 then o.ys = -o.ys end
      if o.y > 60 then o.ys = -o.ys end
      if o.z < -80 then o.zs = -o.zs end
      if o.z > 80 then o.zs = -o.zs end
      o.scale_x = o.scale_x-- + _c(ti.getTime()+o._st)/100
      o.scale_y = o.scale_y-- + _c(ti.getTime()+o._st)/100
      o.scale_z = o.scale_z-- + _c(ti.getTime()+o._st)/100
    end
  end

	--Run through the points and calculate their 2D X and Y
	--Place these values where we can get them later
  for i, p in pairs(points) do
    if object[p.name].update or totalcalcs == 0 then
      p.cx = object[p.name].x + p.x * object[p.name].scale_x
      p.cy = object[p.name].y + p.y * object[p.name].scale_y
      p.cz = object[p.name].z + p.z * object[p.name].scale_z

      x = p.cx
      y = p.cy
      z = p.cz

      xy = cx*y - sx*z
      xz = sx*y + cx*z
      yz = cy*xz - sy*x
      yx = sy*xz + cy*x
      zx = cz*yx - sz*xy
      zy = sz*yx + cz*xy

      scale = focal/(focal + yz)
      x = zx*scale
      y = zy*scale
      z = yz

      p.nx = swidth/2 + x * zoom
      p.ny = sheight/2 + y * zoom
      p.dep = z
      p.s = scale
    end
  end
	timeforupdate1 = (ti.getTime() - ttxx)
end

function love.draw()
  local ttxx = ti.getTime()
  timefordraw1 = 0
  timefordraw2 = 0

	if bgcolor then
		gr.setBackgroundColor(0,0,0)
	else
		gr.setBackgroundColor(255,255,255)
	end

  local d, v
  for i, p in pairs(poly) do
    p.x1 = points[p.p1].nx
    p.y1 = points[p.p1].ny
    p.x2 = points[p.p2].nx
    p.y2 = points[p.p2].ny
    p.x3 = points[p.p3].nx
    p.y3 = points[p.p3].ny
    if p.type == "box" then
      p.x4 = points[p.p4].nx
      p.y4 = points[p.p4].ny
    end

    if p.type == "tri" then
      --p.de = _f((_f(points[p.p1].dep) + _f(points[p.p2].dep) + _f(points[p.p3].dep))/3)
      p.de = lowest(points[p.p1].dep, points[p.p2].dep, points[p.p3].dep, 100000000)
    else
      --p.de = _f((_f(points[p.p1].dep) + _f(points[p.p2].dep) + _f(points[p.p3].dep) + _f(points[p.p4].dep))/4)
      p.de = lowest(points[p.p1].dep, points[p.p2].dep, points[p.p3].dep, points[p.p4].dep)
    end
  end
  timefordraw1 = (ti.getTime() - ttxx)

  sort(poly)

  ttxx = ti.getTime()
	local bf, os
	for i, p in pairs(poly) do
		bf = backface(points[p.p1].nx, points[p.p1].ny, points[p.p1].dep, points[p.p2].nx, points[p.p2].ny, points[p.p2].dep, points[p.p3].nx, points[p.p3].ny, points[p.p3].dep)
		os = onscreen(points[p.p1].dep, points[p.p2].dep, points[p.p3].dep)
		if bf and os then
			local r,g,b = p.nc[1], p.nc[2], p.nc[3]

			o = object[p.name].opacity

      if p.type == "tri" then
        gr.setColor(r, g, b, o)
        gr.triangle("fill", p.x1, p.y1, p.x2, p.y2, p.x3, p.y3)
        if drawlines then
          if blacklines then gr.setColor(0,0,0, 255) end
          gr.triangle("line", p.x1, p.y1, p.x2, p.y2, p.x3, p.y3)
        end
      else
        gr.setColor(r, g, b, o)
        gr.polygon("fill", p.x1, p.y1, p.x2, p.y2, p.x3, p.y3, p.x4, p.y4)
        if drawlines then
          if blacklines then gr.setColor(0,0,0, 255) end
          gr.polygon("line", p.x1, p.y1, p.x2, p.y2, p.x3, p.y3, p.x4, p.y4)
        end
      end
		end
	end

	if shownums or showpoints then
		for i, p in pairs(points) do
      if showpoints then
        gr.setColor(255,255,255,255)
        gr.circle("fill", _f(p.nx), _f(p.ny), .3 * zoom * p.s)
        if p.name == "light" then
          gr.circle("fill", _f(p.nx), _f(p.ny), 3 * zoom * p.s, 32)
        end
      end
      if shownums then
        gr.setColor(0,0,0,255)
        gr.print(i, _f(p.nx-2*zoom), _f(p.ny+3*zoom))
      end
		end
	end

	timefordraw2 = (ti.getTime() - ttxx)

	if debugtext then
		--Print info
		if bgcolor then
			gr.setColor(255,255,255)
		else
			gr.setColor(0,0,0)
		end
		gr.print("FPS: " .. fps .. "\nZoom: " .. zoom .. "\nRot X: " .. rx .. " + " .. rxs .. "\nRot Y: " .. ry .. " + " .. rys .. "\nRot Z: " .. rz .. " + " .. rzs .. "\nOffset: " .. offset .. "\nPoints: " .. #points .. "\nPolys: " .. #poly, 10, 10)
		gr.print("Left/Right: Rotate Y\nLShift+Left/Right: Rotate X\nRShift+Left/Right: Rotate Z\nUp/Down: Zoom\nL: Show/Hide Lines\nH: Show/Hide this text\nB: Background color\nUpdate Time: " .. timeforupdate1 .. "\nDraw Time:    " .. timefordraw1 .. "\n                     " .. timefordraw2, 10, sheight - 150)
	end

	totalcalcs = totalcalcs + 1
end

function love.keypressed(k)
	if k == "l" then drawlines = not drawlines end
	if k == ";" then blacklines = not blacklines end
	if k == "h" then debugtext = not debugtext end
	if k == "n" then shownums = not shownums end
	if k == "b" then bgcolor = not bgcolor end
	if k == "p" then showpoints = not showpoints end
	if k == "f" then print(fps) end
	if k == "q" or k == "escape" then love.event.push("q") end
end

function sort(T) table.sort(T, function(x, y) return x.de > y.de end ) end

function degToRad(d) return d * pi / 180 end

function backface(x1, y1, z1, x2, y2, z2, x3, y3, z3)
	return not ((y3-y1)/(x3-x1) - (y2-y1)/(x2-x1) <= 0) ~= ((x1 <= x3) == (x1 > x2))
end

function lowest(v1, v2, v3, v4)
	return _min(v1, _min(v2, _min(v3, v4)))
end

function highest(v1, v2, v3, v4)
	return _max(v1, _max(v2, _max(v3, v4)))
end

function string:split(delimiter)
	local result = { }
	local from	= 1
	local delim_from, delim_to = string.find( self, delimiter, from	)
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from	= delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from	)
	end
	table.insert( result, string.sub( self, from	) )
	return result
end

-- calculate the cross product from three points
function cross3p(x1, y1, z1, x2, y2, z2, x3, y3, z3)
	-- calculate the two vectors
	a1, a2, a3 = x3-x1, y3-y1, z3-z1
	b1, b2, b3 = x2-x1, y2-y1, z2-z1
	-- cross product
	n1 = a2*b3 - a3*b2
	n2 = a3*b1 - a1*b3
	n3 = a1*b2 - a2*b1
	-- normalization constant
	nl = _sq(n1^2 + n2^2 + n3^2)
	return n1/nl, n2/nl, n3/nl
end

function onscreen(p1, p2, p3)
  if (p1 < -200 or p2 < -200 or p3 < -200) or (p1 > 2000 or p2 > 2000 or p3 > 2000) then return false else return true end
end

function loadObject(f, x, y, z, sx, sy, sz, name, c)
	print("Loading \"" .. name .. "\" (" .. f .. ") at " .. x .. "," .. y .. "," .. z .. " offset.")
  local start = table.getn(points)
	local j = {}
	local i = 0
	local m = 0
	local xx, yy, zz
	local ox, oy, oz = x, y, z
  local pointrep = {}
	for line in love.filesystem.lines(f .. ".j3d") do
	  if line ~= "" then
      if line == "POINTS" then
        m = 1
        i = 0
      elseif line == "POLY" then
        m = 2
        i = 0
      end
      if m == 1 and i > 0 then
        j = line:split(",")
        xx = j[1]
        yy = j[2]
        zz = j[3]

        table.insert(points, { x = tonumber(xx), y = tonumber(yy), z = tonumber(zz), nx, ny, dep, s, scale_x = sx, scale_y = sy, scale_z = sz, name = name })
      elseif m == 2 and i > 0 then
        j = line:split(",")

        local nnn = #poly+1
        local t = "tri"
        if j[7] ~= nil then t = "box" end
        poly[nnn] = {
          p1 = tonumber(start + j[1]),
          p2 = tonumber(start + j[2]),
          p3 = tonumber(start + j[3]),
          c = {tonumber(j[4]),tonumber(j[5]),tonumber(j[6])},
          x1, y1, x2, y2, x3, y3, x4, y4, de, rsize,
          cx = 0, cy = 0, cz = 0, nx = 0, ny = 0, nz = 0,
          name = name, type = t, nc = {0,0,0}
        }
        if t == "box" then
          poly[nnn].p4 = tonumber(start + j[4])
          poly[nnn].c = {tonumber(j[5]),tonumber(j[6]),tonumber(j[7])}
        end
        if c then poly[nnn].c = {c[1], c[2], c[3]} end
      end
      i = i + 1
    end
	end
end

function calculateNormals()
  print("Calculating Normals...")
	if calcNorm then
		local nx, ny, nz, com, nf, x1, x2, x3, y1, y2, y3, z1, z2, z3
		--print("Calculating Normals and Centers")
		for i, p in pairs(poly) do
			x1 = points[p.p1].x
			y1 = points[p.p1].y
			z1 = points[p.p1].z
			x2 = points[p.p2].x
			y2 = points[p.p2].y
			z2 = points[p.p2].z
			x3 = points[p.p3].x
			y3 = points[p.p3].y
			z3 = points[p.p3].z

			p.nx, p.ny, p.nz = cross3p(x1, y1, z1, x2, y2, z2, x3, y3, z3)

			--print(i .. ") " .. p.nx .. "," .. p.ny .. "," .. p.nz)

			p.cx = (points[p.p1].x + points[p.p2].x + points[p.p3].x) / 3
			p.cy = (points[p.p1].y + points[p.p2].y + points[p.p3].y) / 3
			p.cz = (points[p.p1].z + points[p.p2].z + points[p.p3].z) / 3
		end
	end
end

function updateLighting()
  for i, p in pairs(poly) do
    local r,g,b = (ambient.r/255) * p.c[1], (ambient.g/255) * p.c[2], (ambient.b/255) * p.c[3]

    plight = 0
    pshade = 1
    local lx, ly, lz = light.x - p.cx, light.y - p.cy, light.z - p.cz
    local ln = _sq(lx*lx+ly*ly+lz*lz)

    fDot = -(((lx/ln) * p.nx) + ((ly/ln) * p.ny) + ((lz/ln) * p.nz))
    if fDot > 0 then
      plight = fDot * light.intensity
      pshade = pshade - plight

      r = _f(r + p.c[1] * plight)
      g = _f(g + p.c[2] * plight)
      b = _f(b + p.c[3] * plight)

      if r < 0 then r = 0 end
      if g < 0 then g = 0 end
      if b < 0 then b = 0 end
      if r > 255 then r = 255 end
      if g > 255 then g = 255 end
      if b > 255 then b = 255 end
    end
    p.nc[1] = r
    p.nc[2] = g
    p.nc[3] = b
  end
end
